#ifndef RMSCHEDULER_H
#define RMSCHEDULER_H

#include "task.h"

static inline void rm_schedule( Task* t, int n, int h )
{
    int selected = -1; // the currently selected task, < 0 if no task selected

    task_sort_rate( t, 3 );
    task_print( t, 3 );

    // the period is the deadline - therefore a task can either be
    // STOPPED, READY to be scheduled or RUNNING

    // We schedule over one hyper-period
    for( int i = 0; i < h; i++ ) {
        // check if tasks are ready ( period reached )
        // set the state to READY and the remtime to the exectime
        // additionally check if the deadline is violated
        for( int k = 0; k < n; k++ ) {
            // TODO
        }


        // select task with highest priority
        // schedule task with the highest priority and being ready/running
        // if a different task was running set its state to READY
        for( int k = 0; k < n; k++ ) {
            // TODO
        }

        // Schedule the task and print the currently running task
        if( selected < 0 )
            printf("%d: -\n", i );
        else
            printf("%d: %d\n", i, selected + 1 );

        //printf("------- %i ----------\n", i );
        //task_print( t, 3 );

        // if a task was scheduled change its remaining time and
        // if everyting is done set the state to STOPPED
        if( selected >= 0 ) {
            // TODO
        }
    }
}

#endif
